
  <!DOCTYPE html>
  <html>
    <head>
      <title>simulation.ts</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/api/simulation.ts</td><td class="">97.61%</td><td class="">80%</td><td class="">251</td><td class="">245</td><td class="">6</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import { get, post } from &#x27;./methods&#x27;;
import { mapObjectToRows } from &#x27;../pages/projects&#x27;;
import { SimulationMode } from &#x27;../pages/simulation&#x27;;
import {
  createErrorNotification,
  createInfoNotification,
  createSuccessNotification,
  NOTY_TIMEOUT
} from &#x27;../components/notifications&#x27;;

export type KineticSummary = {
  growth_parameters: {
    lysing_rate: number;
    primary_death_rate: number;
    primary_growth_rate: number;
    toxicity_rate: number;
  };
  independent_variables: any[];
  inhibitor_factors: {
    threshold: number;
    variable: &#x27;Bio material&#x27;;
  }[];

  metabolites: any[];
  quadratic_factors: any[];
  substrate_factors: any[];
  user_calculations: any[];
};

export interface SimulationInitialConditions {
  initial_viability: number;
  initial_viable_cell_density: number;
  initial_biomaterial: number;
  initial_lysed_cell_density: number;
}

export type SimulationParameters =
  | {
      volumetric_exchange_rate: number;
      target_viability: number;
      simulation_duration: number;
    }
  | {
      cell_specific_exchange_rate: number;
      target_viable_cell_denisty: number;
      maximum_growth_time: number;
    }
  | {
      target_viable_cell_denisty: number;
      simulation_duration: number;
      media_exchange_start_time: number;
      media_exchange_ratio: number;
      media_exchange_frequency: number;
    }
  | {
      volumetric_exchange_rate: number;
      target_viable_cell_denisty: number;
      simulation_duration: number;
    };

export class SimulationApi {
  static getGrowthKinetics = ({ projectId }: { projectId: string }) =&gt;
    get&lt;{
      kinetic_summary: KineticSummary;
      simulated_data: object;
      fit_statistics: {
        [key: string]: {
          r_squared: number;
          rmse: number;
        };
      };
    }&gt;(`simulation/${projectId}/growth-kinetics`)
      .then((res) =&gt; {
        if (res.status !== 200) {
          createErrorNotification({
            text: &#x27;An error occurred while receiving the prediction&#x27;,
            timeout: NOTY_TIMEOUT
          }).show();
          throw new Error(&#x27;get growth kinetics error&#x27;);
        }
        return res;
      })
      .catch(() =&gt; {
        createErrorNotification({
          text: &#x27;An error occurred while receiving the prediction&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        throw new Error(&#x27;get growth kinetics error&#x27;);
      })
      .then((res) =&gt; {
        return {
          kineticSummary: res.data.kinetic_summary,
          fit_statistics: res.data.fit_statistics,
          simulated_data: Object.keys(res.data.simulated_data).reduce(
            (acc, key) =&gt;
              acc.concat({
                batchName: key,
                data: mapObjectToRows((res.data.simulated_data as any)[key])
              }),
            [] as { batchName: string; data: object[] }[]
          )
        };
      });

  static recalculateGrowthKinetics = ({
    projectId,
    batchId,
    data
  }: {
    projectId: string;
    batchId: string;
    data: object;
  }) =&gt; {
    const recalculateGrowthKineticsNoty = createInfoNotification({
      text: &#x27;The model is being recalculated&#x27;
    });
    recalculateGrowthKineticsNoty.show();
    return post(`simulation/${projectId}/growth-kinetics`, {
      data_set: data
    })
      .then((res) =&gt; {
        if (res.status !== 200) {
          createErrorNotification({
            text: &#x27;An error occurred when starting the model recalculation&#x27;,
            timeout: NOTY_TIMEOUT
          }).show();
          throw new Error(&#x27;recalculate growth kinetics error&#x27;);
        }
        createSuccessNotification({
          text: &#x27;The model recalculation has been successfully completed&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        return res;
      })
      .catch(() =&gt; {
        createErrorNotification({
          text: &#x27;An error occurred when starting the model recalculation&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        throw new Error(&#x27;recalculate growth kinetics error&#x27;);
      })
      .finally(() =&gt;
        setTimeout(() =&gt; recalculateGrowthKineticsNoty.close(), NOTY_TIMEOUT)
      );
  };

  static runSimulation = ({
    projectId,
    ...body
  }: {
    projectId: string;
    initial_conditions: SimulationInitialConditions;
    simulation_parameters: SimulationParameters;
    simulation_mode: SimulationMode;
  }) =&gt; {
    const runSimulationNoty = createInfoNotification({
      text: &#x27;The simulation is being launched&#x27;
    });
    runSimulationNoty.show();
    return post&lt;{
      data: {
        [key: string]: {
          [key: string]: {
            [key: string]: number;
          };
        };
      };
    }&gt;(`simulation/${projectId}`, body)
      .then((res) =&gt; {
        if (res.status !== 200) {
          createErrorNotification({
            text: &#x27;An error occurred when run simulation&#x27;,
            timeout: NOTY_TIMEOUT
          }).show();
          throw new Error(&#x27;run simulation error&#x27;);
        }
        createSuccessNotification({
          text: &#x27;The simulation has been successfully launched&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        return res;
      })
      .then((res) =&gt; {
        const batchNames = Object.keys(res.data.data);
        const parameterNames = Object.keys(
          batchNames.reduce((acc, batchName) =&gt; {
            return {
              ...acc,
              ...Object.keys(res.data.data[batchName]).reduce(
                (acc, param) =&gt; ({ ...acc, [param]: true }),
                {}
              )
            };
          }, {})
        );
        return batchNames.map((batchName) =&gt; {
          const batchValues = res.data.data[batchName];
          return {
            batchName,
            data: parameterNames.reduce(
              (acc, paramName) =&gt; ({
                ...acc,
                [paramName]: Object.keys(batchValues[paramName]).map(
                  (key) =&gt; batchValues[paramName][key]
                )
              }),
              {}
            )
          };
        });
      })
      .catch(() =&gt; {
        createErrorNotification({
          text: &#x27;An error occurred when run simulation&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        throw new Error(&#x27;run simulation error&#x27;);
      })
      .finally(() =&gt;
        setTimeout(() =&gt; runSimulationNoty.close(), NOTY_TIMEOUT / 2)
      );
  };
}
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/api/simulation.ts&quot;,&quot;line&quot;:17,&quot;character&quot;:2,&quot;text&quot;:&quot;independent_variables&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/api/simulation.ts&quot;,&quot;line&quot;:23,&quot;character&quot;:2,&quot;text&quot;:&quot;metabolites&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/api/simulation.ts&quot;,&quot;line&quot;:24,&quot;character&quot;:2,&quot;text&quot;:&quot;quadratic_factors&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/api/simulation.ts&quot;,&quot;line&quot;:25,&quot;character&quot;:2,&quot;text&quot;:&quot;substrate_factors&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/api/simulation.ts&quot;,&quot;line&quot;:26,&quot;character&quot;:2,&quot;text&quot;:&quot;user_calculations&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/api/simulation.ts&quot;,&quot;line&quot;:97,&quot;character&quot;:39,&quot;text&quot;:&quot;res.data.simulated_data as any&quot;,&quot;kind&quot;:3}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  